Arch CloseHoles: Difference between revisions

From FreeCAD Documentation
No edit summary
No edit summary
Line 3: Line 3:


<!--T:10-->
<!--T:10-->
{{docnav
{{Docnav
|[[Arch_RemoveShape|Remove Shape]]
|[[Arch_RemoveShape|Remove Shape]]
|[[Arch_MergeWalls|Merge Walls]]
|[[Arch_MergeWalls|Merge Walls]]
Line 16: Line 16:
|Name=Arch CloseHoles
|Name=Arch CloseHoles
|MenuLocation=Arch → Utilities → Close Holes
|MenuLocation=Arch → Utilities → Close Holes
|Workbenches=[[Arch Module|Arch]]
|Workbenches=[[Arch_Module|Arch]]
|SeeAlso=[[Arch Check|Arch Check]]
|SeeAlso=[[Arch_Check|Arch Check]]
}}
}}


Line 71: Line 71:


<!--T:12-->
<!--T:12-->
{{docnav
{{Docnav
|[[Arch_RemoveShape|Remove Shape]]
|[[Arch_RemoveShape|Remove Shape]]
|[[Arch_MergeWalls|Merge Walls]]
|[[Arch_MergeWalls|Merge Walls]]

Revision as of 20:40, 24 November 2020

Arch CloseHoles

Menu location
Arch → Utilities → Close Holes
Workbenches
Arch
Default shortcut
None
Introduced in version
-
See also
Arch Check

Description

This tool identifies holes (circular sequence of open edges) in a Shape object and attempts to close it by adding it a new face made from that edges sequence. You must still verify yourself that the result is a solid, though.

Usage

  1. Select a Shape object.
  2. Press the Close Holes entry in Arch → Utilities → Close Holes.

Scripting

See also: Arch API and FreeCAD Scripting Basics.

This tool can be used in macros and from the Python console by using the following function:

solid = closeHole(shape)
  • Closes a hole in a shape, which is a Part.Shape, and returns the new solid object.

Example:

import FreeCAD, Draft, Arch

Line = Draft.makeWire([FreeCAD.Vector(0, 0, 0),FreeCAD.Vector(2000, 2000, 0)])
Wall = Arch.makeWall(Line, width=150, height=3000)

Box = FreeCAD.ActiveDocument.addObject("Part::Box", "Box")
Box.Length = 900
Box.Width = 450
Box.Height = 2000
FreeCAD.ActiveDocument.recompute()

Draft.rotate(Box, 45)
Draft.move(Box, FreeCAD.Vector(1000, 700, 0))

Arch.removeComponents(Box, Wall)
FreeCAD.ActiveDocument.recompute() 

solid = Arch.closeHole(Wall.Shape)